// DrawAndDrawView.cpp : implementation of the CDrawAndDrawView class
//

#include "stdafx.h"
#include "DrawAndDraw.h"

#include "DrawAndDrawView.h"

#include "MainFrm.h"
#include "DrawAndDrawDoc.h"
#include "DrawViewSize.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrawAndDrawView

IMPLEMENT_DYNCREATE(CDrawAndDrawView, CView)

BEGIN_MESSAGE_MAP(CDrawAndDrawView, CView)
	//{{AFX_MSG_MAP(CDrawAndDrawView)
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_SIZE()
	ON_COMMAND(ID_WHITE, OnWhite)
	ON_COMMAND(ID_GRAY, OnGray)
	ON_COMMAND(ID_BLACK, OnBlack)
	ON_COMMAND(ID_RED, OnRed)
	ON_COMMAND(ID_GREEN, OnGreen)
	ON_COMMAND(ID_BLUE, OnBlue)
	ON_COMMAND(ID_SILVER, OnSilver)
	ON_COMMAND(ID_NAVY, OnNavy)
	ON_COMMAND(ID_YELLOW, OnYellow)
	ON_COMMAND(ID_OLIVE, OnOlive)
	ON_COMMAND(ID_FUCHIA, OnFuchia)
	ON_COMMAND(ID_TEAL, OnTeal)
	ON_COMMAND(ID_PENCIL, OnPencil)
	ON_COMMAND(ID_PEN, OnPen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawAndDrawView construction/destruction

CDrawAndDrawView::CDrawAndDrawView()
{
      m_bmInitCell.LoadBitmap (IDB_SILVER);

	// TODO: add construction code here
}

CDrawAndDrawView::~CDrawAndDrawView()
{

}

BOOL CDrawAndDrawView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
  
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDrawAndDrawView drawing

void CDrawAndDrawView::OnDraw(CDC* pDC)
{
	CDrawAndDrawDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

    CSize size = pDoc->GetGridSize ();
	CDC mdcDefault, mdcBlue;
    CRect rect;
    int i, j;

    rect = ((CPaintDC*) pDC)->m_ps.rcPaint;
    pDC->DPtoLP (&rect);

    int x1, y1, x2, y2;
    x1 = max (0, (rect.left - m_ptOrg.x) / CELLWIDTH);
    y1 = max (0, (rect.top - m_ptOrg.y) / CELLHEIGHT);
    x2 = min (size.cx, ((rect.right - m_ptOrg.x) / CELLWIDTH) + 1);
    y2 = min (size.cy, ((rect.bottom - m_ptOrg.y) / CELLHEIGHT) + 1);

	mdcDefault.CreateCompatibleDC (pDC);
	CBitmap* pOldDefaultBitmap = mdcDefault.SelectObject (&m_bmInitCell);

    for (i=y1; i<y2; i++)
	{
	    for (j=x1; j<x2; j++)
		{
			pDC->BitBlt (m_ptOrg.x + (j * CELLWIDTH),
		        m_ptOrg.y + (i * CELLHEIGHT), CELLWIDTH, CELLHEIGHT,
			    &mdcDefault, 0, 0, SRCCOPY);
		}
   }
    mdcDefault.SelectObject (pOldDefaultBitmap);
 
	// TODO: add draw code for native data here: 
}

/////////////////////////////////////////////////////////////////////////////
// CDrawAndDrawView diagnostics

#ifdef _DEBUG
void CDrawAndDrawView::AssertValid() const
{
	CView::AssertValid();
}

void CDrawAndDrawView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDrawAndDrawDoc* CDrawAndDrawView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDrawAndDrawDoc)));
	return (CDrawAndDrawDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawAndDrawView message handlers

BOOL CDrawAndDrawView::OnEraseBkgnd(CDC* pDC) 
{
	CRect rect;
    GetClientRect (&rect);
    CBrush brush ((COLORREF) ::GetSysColor (COLOR_APPWORKSPACE));
    pDC->FillRect (rect, &brush);
	// TODO: Add your message handler code here and/or call default
	
	return CView::OnEraseBkgnd(pDC);
}

void CDrawAndDrawView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	m_nPrevRow = -1;
    m_nPrevCol = -1;

    CRect rect;
    GetClientRect (&rect);
    SetGridOrigin (rect.Width (), rect.Height ());

	HCURSOR hCursor = AfxGetApp()->LoadCursor(IDC_PENCIL);
	SetCursor(hCursor);	
	// TODO: Add your specialized code here and/or call the base class

}

void CDrawAndDrawView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDrawAndDrawDoc* pDoc = GetDocument ();
    CSize size = pDoc->GetGridSize ();

    if ((point.x < m_ptOrg.x) ||
        (point.x > (m_ptOrg.x + (size.cx * CELLWIDTH))) ||
        (point.y < m_ptOrg.y) ||
        (point.y > (m_ptOrg.y + (size.cy * CELLHEIGHT))))
        return;

    point.x -= m_ptOrg.x;
    point.y -= m_ptOrg.y;

    CClientDC dc (this);
    OnPrepareDC (&dc);
    dc.DPtoLP (&point);
	
    int nRow = point.y / CELLHEIGHT;
    int nCol = point.x / CELLWIDTH;

    m_nPrevRow = nRow;
    m_nPrevCol = nCol;

    DrawCell (&dc); 
	// TODO: Add your message handler code here and/or call default
	
	CView::OnLButtonDown(nFlags, point);
}

void CDrawAndDrawView::StatusBarData()
{
	CString color;
	char vline[10];
	char vcolumn[10];
	CString vLn = "Ln ";
	CString vCol = " , Col ";
	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();
 
   _itoa( m_nPrevRow, vline, 10 );
   _itoa( m_nPrevCol, vcolumn, 10 );
	if (m_color != _T(""))
	{
		color = m_color + ", Ln " + vline + " , Col " + vcolumn;
	}
	else
	{
		color = vLn + vline + vCol + vcolumn;
	}
	pMainWnd->m_wndStatusBar.SetPaneText(2,color,TRUE);

	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::CurCursor()	
{
	if (m_cursor == _T("pencil"))
		SetCursor(AfxGetApp()->LoadCursor(IDC_PENCIL));
	if (m_cursor == _T("pen"))
		SetCursor(AfxGetApp()->LoadCursor(IDC_PEN));
}

void CDrawAndDrawView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (!(nFlags & MK_LBUTTON))
        return;

    CDrawAndDrawDoc* pDoc = GetDocument ();
    CSize size = pDoc->GetGridSize ();

	if ((m_cursor != _T("")) && (m_color != _T("")) )
		CurCursor();	

    if ((point.x < m_ptOrg.x) ||
        (point.x > (m_ptOrg.x + (size.cx * CELLWIDTH))) ||
        (point.y < m_ptOrg.y) ||
        (point.y > (m_ptOrg.y + (size.cy * CELLHEIGHT))))
        return;

    point.x -= m_ptOrg.x;
    point.y -= m_ptOrg.y;

    CClientDC dc (this);
    OnPrepareDC (&dc);
    dc.DPtoLP (&point);

    int nRow = point.y / CELLHEIGHT;
    int nCol = point.x / CELLWIDTH;

    if ((nRow == m_nPrevRow) && (nCol == m_nPrevCol))
        return;

    m_nPrevRow = nRow;
    m_nPrevCol = nCol;

	StatusBarData();

    DrawCell (&dc); 
	// TODO: Add your message handler code here and/or call default
	
	CView::OnMouseMove(nFlags, point);
}

void CDrawAndDrawView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);

	CView::OnSize(nType, cx, cy);
    SetGridOrigin (cx, cy);
	// TODO: Add your message handler code here
	
}

void CDrawAndDrawView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	Invalidate (lHint ? FALSE : TRUE);
	// TODO: Add your specialized code here and/or call the base class
}

void  CDrawAndDrawView::CurBitmap()
{

	m_bmCurCell.DeleteObject();
	m_bmCurCell.Attach(m_bmCurCell);

	if (m_color == _T("white"))
	    m_bmCurCell.LoadBitmap (IDB_WHITE);
	if (m_color == _T("silver"))
	    m_bmCurCell.LoadBitmap (IDB_SILVER);
	if (m_color == _T("gray")) 
	    m_bmCurCell.LoadBitmap (IDB_GRAY);
	if (m_color == _T("black"))
	    m_bmCurCell.LoadBitmap (IDB_BLACK);
	if (m_color == _T("red"))
	    m_bmCurCell.LoadBitmap (IDB_RED);
	if (m_color == _T("green"))
	    m_bmCurCell.LoadBitmap (IDB_GREEN);
	if (m_color == _T("blue"))
	    m_bmCurCell.LoadBitmap (IDB_BLUE);

	if (m_color == _T("navy"))
	    m_bmCurCell.LoadBitmap (IDB_NAVY);

	if (m_color == _T("yellow"))
	    m_bmCurCell.LoadBitmap (IDB_YELLOW);
	if (m_color == _T("olive"))
	    m_bmCurCell.LoadBitmap (IDB_OLIVE);
	if (m_color == _T("fuchia"))
	    m_bmCurCell.LoadBitmap (IDB_FUCHIA);
	if (m_color == _T("teal"))
	    m_bmCurCell.LoadBitmap (IDB_TEAL);

}

void CDrawAndDrawView::DrawCell (CDC* pDC)
{
    CDC     mdc;

	mdc.CreateCompatibleDC(pDC);

	pCurBitmap = mdc.SelectObject (&m_bmCurCell);

	pDC->BitBlt (m_ptOrg.x + (m_nPrevCol * CELLWIDTH),
        m_ptOrg.y + (m_nPrevRow * CELLHEIGHT), CELLWIDTH, CELLHEIGHT, &mdc,
        0, 0, SRCCOPY);

    mdc.SelectObject (pCurBitmap);
}

void CDrawAndDrawView::SetGridOrigin (int cx, int cy)
{
    m_ptOrg.x = m_ptOrg.y = 0;
    CSize size = GetDocument ()->GetGridSize ();
    if (cx > (size.cx * CELLWIDTH))
        m_ptOrg.x = (cx - (size.cx * CELLWIDTH)) / 2;
    if (cy > (size.cy * CELLHEIGHT))
        m_ptOrg.y = (cy - (size.cy * CELLHEIGHT)) / 2;

}

void CDrawAndDrawView::OnWhite() 
{
	m_color = _T("white");
	CurBitmap();

	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnSilver() 
{
	m_color = _T("silver");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnGray() 
{
	m_color = _T("gray");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnBlack() 
{
	m_color = _T("black");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnRed() 
{
	m_color = _T("red");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnGreen() 
{
	m_color = _T("green");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnBlue() 
{
	m_color = _T("blue");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnNavy() 
{
	m_color = _T("navy");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnYellow() 
{
	m_color = _T("yellow");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnOlive() 
{
	m_color = _T("olive");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnFuchia() 
{
	m_color = _T("fuchia");
	CurBitmap();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnTeal() 
{
	m_color = _T("teal");
	CurBitmap();
	// TODO: Add your command handler code here
	
}



void CDrawAndDrawView::OnPencil() 
{
	m_cursor = _T("pencil");
	CurCursor();
	// TODO: Add your command handler code here
	
}

void CDrawAndDrawView::OnPen() 
{
	m_cursor = _T("pen");
	CurCursor();
	// TODO: Add your command handler code here
	
}
